#include "BeatSequence.h"
#include <iostream>

using namespace midi;

void conflict(BeatSequence& sequence, BeatSequence::BeatIndex factor, BeatSequence::BeatIndex beatIndex, void* data)
{
    std::cout << beatIndex << " " << data << std::endl;
    sequence[beatIndex].clear();
}

int main()
{
    BeatSequence s(13);
    for(BeatSequence::BeatIndex b = 0; b < s.size(); b++) {
        s[b].push_back(std::make_shared<NoteOnMessage>(b, b * 10, 1));
        s[b].push_back(std::make_shared<NoteOffMessage>(b, b * 10, 2));
    }

    s.print(std::cout);

    s.reduce(3, conflict, (void*)1234);
    s.print(std::cout);

    return 0;
}
